"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WidgetDisplay = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

/**
 * Component used to render a widget view.
 *
 * Given a kernel and widget model id, this component will render a widget
 * view for the widget model. The widget view and widget models are isolated to
 * a cross domain iframe. Since they have access to the kernel, they are capable
 * of communicating directly with the kernel instance which makes them atypical.
 *
 * Even though it may appear to be pure, since it doesn't have react state, this
 * component's iframe maintains it's own state in communication with the kernel.
 */
var WidgetDisplay =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(WidgetDisplay, _React$Component);

  function WidgetDisplay() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, WidgetDisplay);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(WidgetDisplay)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "container", _react.default.createRef());
    return _this;
  }

  (0, _createClass2.default)(WidgetDisplay, [{
    key: "componentDidMount",

    /** @override */
    value: function componentDidMount() {
      if (!this.container.current) return; // When the component has mounted, inject the widget iframe.
      // const view = this.shim.getView();
      // this.container.current.appendChild(view);
    }
    /** @override */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {} // if (this.shim) {
    //   this.shim.dispose();
    //   delete this.shim;
    // }

    /** @override */

  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      // Only update if the model_id or kernel_id have changed.
      if (nextProps.data.model_id !== this.props.data.model_id) {
        return true;
      } // If the channels have changed, we need to make sure that we connect the
      // shim to the new channels.


      if (nextProps.channels !== this.props.channels) {
        return true;
      }

      return false;
    }
    /** @override */

  }, {
    key: "render",
    value: function render() {
      this.createOrUpdateShim();
      return _react.default.createElement("pre", null, "Jupyter-Widgets are not yet supported in nteract.", _react.default.createElement("div", {
        ref: this.container
      }));
    }
    /**
     * Creates or updates the existing shim to the current model id and kernel.
     */

  }, {
    key: "createOrUpdateShim",
    value: function createOrUpdateShim() {// if (!this.shim) {
      //   this.shim = new OuterShim();
      // }
      // this.shim.setCommMsgsSubject(this.props.channels);
      // this.shim.setModelId(this.props.data.model_id);
    }
  }]);
  return WidgetDisplay;
}(_react.default.Component);

exports.WidgetDisplay = WidgetDisplay;
(0, _defineProperty2.default)(WidgetDisplay, "MIMETYPE", "application/vnd.jupyter.widget-view+json");